/********************************************************************/
/*** Invocador de WIT para Linux por Norwegian (norwegian@jet.es) ***/
/*** Actualizacin a 0.2 por _CN_ <cn_set@inicia.es>              ***/
/**** Porque Los Linuxeros tb tenemos dereho a jugar al Trivial. ****/
/********************************************************************/
/*** 2 - VI - 2001 ***/
/*** No se como se hace, pero esto deberia distribuirse bajo ***/
/*** Licencia GPL ***/

#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

int version();
int help(char *);

int main(int argc, char *argv[])
{
	struct sockaddr_in PeleHost;
	struct sockaddr_in HispaHost;
	struct hostent *Resolver;

	int SocketPeletier;
	int SocketHispano;
	int Conectado;
	int ResultadoSelect;
	int Resultado2;

	char canal[20];
	char Cadena[1024];
	char CadenaCanal[1024];
	char Servidor[1024];

	char c;	/* Parametros */

	int Resultado;
	fd_set grupo_socks;
	int Imprime=1;

	printf("WitSummon 0.2 para Linux\n");

	do {
		c=getopt(argc, argv, "svh");
		switch(c) {
			case -1:
				if(argv[optind]!=NULL)
					strcpy(canal, argv[optind]);
				else {
					printf("Debe especificar un canal\n");
					exit(-1);
				}
				break;
			case 's':
				Imprime=0;
				break;
			case 'v':
				version();
				exit(1);
				break;
			case 'h':
				help(argv[0]);
				exit(1);
				break;
		}
	} while (c>0);

	/* Conectar a peletier.com 5520 */
	SocketPeletier=socket(AF_INET, SOCK_STREAM, 0);

	memset(&PeleHost, 0, sizeof(PeleHost));

	PeleHost.sin_family=AF_INET;
	PeleHost.sin_port=htons(5520);
	PeleHost.sin_addr.s_addr=inet_addr("80.59.170.174");

	if (Resolver = gethostbyname("wit.peletier.com"))
		bcopy(Resolver->h_addr, (char *)&PeleHost.sin_addr, Resolver->h_length);

	Conectado=connect(SocketPeletier, (struct sockaddr *)&PeleHost, 16);
	if(Conectado==-1) {
		perror("connect");
		exit(-1);
	}

	/* Recibimiento y envio de VERSION */

	memset(Cadena, 0, 1024);
	Resultado=recv(SocketPeletier, Cadena, 1024, 0);
	printf("%s", Cadena);

	printf("Enviando Version...\n");
	Resultado=send(SocketPeletier, "VERSION 1.0\n", 12, 0);

	/* Recibir cadena FORCECONNECT */

	printf("Recibiendo FORCECONNECT...\n");
	
	memset(Cadena, 0, 1024);
	Resultado=recv(SocketPeletier, Cadena, 1024, 0);

	/* Sacar la Variable Servidor de FORCECONNECT */
	/* Se puede hacer mejor, pero no mas claro :) */

	Resultado2=0;
	Resultado=13;

	while(Cadena[Resultado++]!=' ')
		Servidor[Resultado2++]=Cadena[Resultado-1];

	Servidor[Resultado2]='\0';
	printf("Usando Servidor: %s\n", Servidor);

	/* Enviar Informacion: Aqui hay que trastocar argv[] */

	Resultado=send(SocketPeletier, "USER anonymous connect\n", 23, 0);

	sprintf(CadenaCanal, "CHANNEL #%s\n", canal);

	printf("Usando Canal #%s\n", canal);

	if (!Imprime) printf("Modo Silente...\n");

	Resultado=send(SocketPeletier, CadenaCanal, strlen(CadenaCanal), 0);
	Resultado=send(SocketPeletier, "DONE\n", 5, 0);


	/* Conectar al IRC */

	printf("Conectando Al Servidor IRC...\n");

	SocketHispano=socket(AF_INET, SOCK_STREAM, 0);

	memset(&HispaHost, 0, sizeof(HispaHost));
	HispaHost.sin_family=AF_INET;
	HispaHost.sin_port=htons(6667);

	if ((Resolver = gethostbyname(Servidor))!=NULL)
		bcopy(Resolver->h_addr, (char *)&HispaHost.sin_addr, Resolver->h_length);
	else {
		  if ((HispaHost.sin_addr.s_addr=inet_addr(argv[1])) < 0) {
			  printf("El Nombre del Servidor es Incorrecto\n");
			  exit (0);
		  }
	}

	if ((Conectado=connect(SocketHispano, (struct sockaddr *)&HispaHost, 16))==-1) {
		perror("connect");
		exit(-1);
	}
	printf("Conectado\n");

	/* Enviar CONNECTED a peletier.com */

	Resultado=send(SocketPeletier, "CONNECTED\n", 10, 0);

	/* Preparar SET de Descriptores */

	printf("Iniciando dialogo...");

	do {
		FD_ZERO(&grupo_socks);
		FD_SET(SocketHispano, &grupo_socks);
		FD_SET(SocketPeletier, &grupo_socks);

		if ((ResultadoSelect=select(10, &grupo_socks, NULL, NULL, NULL))<0) {
		        perror("select");
		        exit(0);
		}

		if (FD_ISSET(SocketPeletier, &grupo_socks)) {
			memset(Cadena, 0, 1024);
		        Resultado=recv(SocketPeletier, Cadena, 1024, 0);
		        if (Imprime) printf(Cadena);
		        Resultado2=send(SocketHispano, Cadena, Resultado, 0);
		}
		
		if (FD_ISSET(SocketHispano, &grupo_socks)) {
			memset(Cadena, 0, 1024);
		        Resultado=recv(SocketHispano, Cadena, 1024, 0);
		        if (Imprime) printf(Cadena);
		        Resultado2=send(SocketPeletier, Cadena, Resultado, 0);
		}

	} while(1);
}


int version()
{

	printf("Versin original por Norwegian <norwegian@jet.es>\n");
	printf("Actualizacin a 0.2 por _CN_ <cn_set@inicia.es>\n");
	printf("Versin autorizada por peletier.com\n");
	printf("La ltima versin de este software puede encontrarse en www.peletier.com\n");
	printf("Este software debe ser distribuido bajo licencia GPL\n");
}

int help(char nombre[])
{
	version();
        printf("\nUso:\n");
        printf("\t%s [OPCIONES]... [CANAL]\n", nombre);
        printf("\t-s \tModo silencioso\n");
        printf("\t-v \tMuestra informacin sobre la versin\n");
        printf("\t-h \tEsta ayuda\n");
}
